//
// SCells is a freeware program for HSPascal.
// SCells Version 1.1 - October 30, 2001 - Made by Laurent Duveau
//       Web Site = http://aldweb.free.fr
//       e-Mail   = aldweb@free.fr
//
// SCells is based on the source code of Cells freeware.
// Cells Version 1.2 - August 18, 2001 - Made by Laurent Duveau
//
// SCells was compiled with the great HSPascal compiler
// for Palm OS handheld devices
//       Web Site = http://HSPascal.Fihl.net
//       e-Mail   = Christen@Fihl.net
//
// The original source code of Cells was slightly modified  
// for Speedy tests purposes, and the program was renamed 
// as SCells for no confusion making.
//


Program SCells;

{$SearchPath Units; Units\UI; Units\System}
{$ApplName SCells,LDSC}  
// LDSC is NOT a referenced PalmOS CreatorID


Uses
  Window, Form, Menu, Rect, Event, SysEvent, SystemMgr, FloatMgr, HSUtils, 
  TimeMgr, Preferences;

Resource
  MenuRes=(ResMBAR,,
    (ResMPUL,(6,14,85,88),(4,0,35,12),'Game',   
      MenuNewGame=(,'G','New Game'),
      MenuLoad1=(,'1','Load #1'),
      MenuLoad2=(,'2','Load #2'),
      MenuLoad3=(,'3','Load #3'),
      MenuSave1=(,'a','Save #1'),
      MenuSave2=(,'b','Save #2'),
      MenuSave3=(,'c','Save #3'),
      MenuQuit=(,'X','Exit')),
    (ResMPUL,(42,14,90,66),(40,0,47,12),'Options',   
      MenuEditCurrent=(,'C','Edit Current'),
      MenuEditNew=(,'N','Edit New'),
      MenuEndEdit=(,'E','End Edit'),
      MenuFilling=(,'F','Filling'),
      MenuSpeed=(,'S','Speed'),
      MenuSize=(,'I','Cell Size')),
    (ResMPUL,(90,14,60,33),(88,0,30,12),'Help',  
      MenuHelp=(,'H','Help'),
      MenuRules=(,'R','Rules'),
      MenuAbout=(,'A','About')));

  MainForm=(ResTFRM,1000,(0,0,160,160),0,0,0, (FormTitle,'SCells'));

  Help1=(ResTalt,,0,0,0,'Cells - Help','Cells is a port of the popular "Game of '+
          'Life" invented in 1970 by John Conway.'#10#10+ 
          'In an automata universe, cells follow very basic rules to survive, be born '+
          'or die in a turn based simulation.','Ok');
  Rule1=(ResTalt,,0,0,0,'Cells - Rules','Survival:'#10'If a cell has 2 or 3 alive cells '+
         'next to it, it will survive. Otherwise, it will die.'#10#10'Birth:'#10+
         'If an empty space is surrounded by 3 cells, it will come up to life.','Ok');
  HelpAbout1=(ResTSTR,,'Cells is a sample freeware program compiled with the great '+
              'HSPascal compiler for Palm OS handheld devices.'#10#10+ 
              'HSPascal can be found there:'#10'http://HSPascal.Fihl.net');
  About1=(ResTalt,,0,HelpAbout1,0,'Cells - About', 'Cells  v1.2'#10+
          #9'August 18, 2001'#10#9'by Laurent Duveau'#10#10+
          'Visit my Web site:'#10'http://aldweb.free.fr'#10#10+
          'e-Mail me:'#10'aldweb@free.fr','Ok');
  StartNewGame1=(ResTalt,,0,0,0,'Cells - New game','Do you really want to start '+
                 'a new simulation ?','Yes','No');
  HelpSpeed1=(ResTSTR,,'Speed option sets the time that the Palm will wait before '+
              'moving to the next generation of Cells.'#10#10+ 
              'If set to "Manual", you will have to tick on the screen to move to '+
              'the next generation.');
  Speed1=(ResTalt,,0,HelpSpeed1,0,'Cells - Speed','Current speed is :'#10#9'0 second'+
          #10#10'Choose a new speed ?','0 sec','1 sec','2 sec','Manual');
  Speed2=(ResTalt,,0,HelpSpeed1,0,'Cells - Speed','Current speed is :'#10#9'1 second'+
          #10#10'Choose a new speed ?','0 sec','1 sec','2 sec','Manual');
  Speed3=(ResTalt,,0,HelpSpeed1,0,'Cells - Speed','Current speed is :'#10#9'2 seconds'+
          #10#10'Choose a new speed ?','0 sec','1 sec','2 sec','Manual');
  Speed4=(ResTalt,,0,HelpSpeed1,0,'Cells - Speed','Current speed is :'#10#9'Manual'+
          #10#10'Choose a new speed ?','0 sec','1 sec','2 sec','Manual');
  HelpFilling1=(ResTSTR,,'Filling option sets the initial percentage of spaces to be '+
                 'turned into Cells at the beginning of the game.'#10#10+
                 'This setup will be used next time you start a new game.');
  Filling1=(ResTalt,,0,HelpFilling1,0,'Cells - Filling','Current initial filling is :'#10#9'10%'+
            #10#10'Choose a new filling ?','10%','15%','20%','25%');
  Filling2=(ResTalt,,0,HelpFilling1,0,'Cells - Filling','Current initial filling is :'#10#9'15%'+
            #10#10'Choose a new filling ?','10%','15%','20%','25%');
  Filling3=(ResTalt,,0,HelpFilling1,0,'Cells - Filling','Current initial filling is :'#10#9'20%'+
            #10#10'Choose a new filling ?','10%','15%','20%','25%');
  Filling4=(ResTalt,,0,HelpFilling1,0,'Cells - Filling','Current initial filling is :'#10#9'25%'+
            #10#10'Choose a new filling ?','10%','15%','20%','25%');
  CellSize1=(ResTalt,,0,0,0,'Cells - Size','Current size of cells is :'#10#9'Small'+
            #10#10'Choose a new size ?','Small','Medium','Big');
  CellSize2=(ResTalt,,0,0,0,'Cells - Size','Current size of cells is :'#10#9'Medium'+
            #10#10'Choose a new size ?','Small','Medium','Big');
  CellSize3=(ResTalt,,0,0,0,'Cells - Size','Current size of cells is :'#10#9'Big'+
            #10#10'Choose a new size ?','Small','Medium','Big');
  NoLoad1=(ResTalt,,0,0,0,'Cells - Load Game','No saved game #1 yet.','Ok');
  NoLoad2=(ResTalt,,0,0,0,'Cells - Load Game','No saved game #2 yet.','Ok');
  NoLoad3=(ResTalt,,0,0,0,'Cells - Load Game','No saved game #3 yet.','Ok');
  Saved1=(ResTalt,,0,0,0,'Cells - Save Game','Game #1 saved.','Ok');
  Saved2=(ResTalt,,0,0,0,'Cells - Save Game','Game #2 saved.','Ok');
  Saved3=(ResTalt,,0,0,0,'Cells - Save Game','Game #3 saved.','Ok');

  ResultWindow=(ResTalt,,0,0,0,'SCells - Timer Results','^1 ^2 ^3','Ok');

  (ResTAIN,1000,'SCells');
  (ResTVER,1000,'1.1');


Const
  CreatorID=$4C445343;      // LDSC
  CellXmaxSize = 53;
  CellYmaxSize = 48;

Type
  TStatus = record
              Previous : Boolean;
              Current  : Boolean;
            end;
  TCells = Array[0..CellXmaxSize+1,0..CellYmaxSize+1] of TStatus;

Var
  DelaySeed: Integer;
  MyMenu: MenuBarPtr;
  DoStop: Boolean;
  Speed: Integer;
  Filling: Integer;
  CellSize: Integer;
  CellXmax: Integer;
  CellYmax: Integer;
  TickDown: Boolean;
  WorkRect: RectangleType;
  FormLoad,FormOpen: Boolean;
  Cells: TCells;
  Editor: Boolean;
  DlySeed: LongInt;

Procedure StartTimer;
begin
  DlySeed:=TimGetSeconds;
end;

Function StopTimer: LongInt;
begin
  StopTimer:=TimGetSeconds-DlySeed;
end;


Procedure InitCurrentCells(StartX,StartY: Integer);
Var
  X,Y: Integer;
begin
  for X:=1 to CellXmaxSize do
    for Y:=1 to CellYmaxSize do 
      if (X>=StartX) or (Y>=StartY)
        then Cells[X,Y].Current:=False;
end;

Procedure CalcCellSize;
Var
  X,Y: Integer;
begin
  CellXmax:= 160 div CellSize;
  CellYmax:= 144 div CellSize;
  InitCurrentCells(CellXmax+1,CellYmax+1);
end;

Procedure InitVar;
begin
  DelaySeed:=TimGetSeconds;
  FormLoad:=False;
  FormOpen:=False;
  TickDown:=False;
  DoStop:=False;
  Speed:=0;
  Filling:=1;
  Editor:=False;
  CellSize:=3;
  CalcCellSize;
end;

Procedure DrawCell(X,Y: Integer; DrawIt: Boolean);
Var
  Rec: RectangleType;
begin
  With Rec do begin
    topLeft.X := X;
    topLeft.y := Y;
    extent.x  := CellSize-1;
    extent.y  := CellSize-1;
    if DrawIt then
      WinDrawRectangle(Rec,0)          
    else
      WinEraseRectangle(Rec,0);
   end;
end;

Procedure DrawGameBoard;
Var
  X,Y: Integer;
begin
  for X:=0 to CellXmax-1 do
    for Y:=0 to CellYmax-1 do 
      if Cells[X+1,Y+1].Current<>Cells[X+1,Y+1].Previous then 
        if Cells[X+1,Y+1].Current then 
          DrawCell(X*CellSize,17+Y*CellSize,True)
        else 
          DrawCell(X*CellSize,17+Y*CellSize,False); 
end;

Procedure EditCell(X,Y:Integer);
begin
  X:=1+X div CellSize;
  Y:=1+(Y-17) div CellSize;
  Cells[X,Y].Previous:=Cells[X,Y].Current;
  Cells[X,Y].Current:=not(Cells[X,Y].Current);
  DrawGameBoard;
end;

Procedure InitPreviousCells;
Var
  X,Y: Integer;
begin
  for X:=0 to CellXmaxSize+1 do
    for Y:=0 to CellYmaxSize+1 do 
      Cells[X,Y].Previous:=False;
end;

Procedure EraseDrawBoard;
begin
  InitPreviousCells;
  WinEraseRectangle(WorkRect, 0);
  DrawGameBoard; 
end;

Procedure InitCells;
Var
  X,Y: Integer;
begin
  InitCurrentCells(0,0);
  for X:=1 to CellXmax do
    for Y:=1 to CellYmax do 
      if Random(100)<5*(Filling+2) then  
        Cells[X,Y].Current:=True
      else
        Cells[X,Y].Current:=False;
  EraseDrawBoard;
end;

Procedure SavePreferences(GameID:Integer);
Var
  N: Integer;
begin
  if GameID=0 then begin
    case Speed of
      0: begin
           Cells[0,0].Previous:=False;
           Cells[0,1].Previous:=False;
         end;
      1: begin
           Cells[0,0].Previous:=True;
           Cells[0,1].Previous:=False;
         end;
      2: begin
           Cells[0,0].Previous:=False;
           Cells[0,1].Previous:=True;
         end;
      3: begin
           Cells[0,0].Previous:=True;
           Cells[0,1].Previous:=True;
         end;
    end;
    case Filling of
      0: begin
           Cells[0,2].Previous:=False;
           Cells[0,3].Previous:=False;
         end;
      1: begin
           Cells[0,2].Previous:=True;
           Cells[0,3].Previous:=False;
         end;
      2: begin
           Cells[0,2].Previous:=False;
           Cells[0,3].Previous:=True;
         end;
      3: begin
           Cells[0,2].Previous:=True;
           Cells[0,3].Previous:=True;
         end;
    end;
    Cells[0,4].Previous:=Editor;
  end;
  case CellSize of
    3: begin
         Cells[0,5].Previous:=False;
         Cells[0,6].Previous:=False;
       end;
    4: begin
         Cells[0,5].Previous:=True;
         Cells[0,6].Previous:=False;
       end;
    5: begin
         Cells[0,5].Previous:=False;
         Cells[0,6].Previous:=True;
       end;
    end;
  PrefSetAppPreferences(CreatorID,GameID,0,@Cells,SizeOf(Cells),True);
  case GameID of
    1: N:=FrmAlert(Saved1);
    2: N:=FrmAlert(Saved2);
    3: N:=FrmAlert(Saved3);
  end;
end;

Function BinaryCells(BCell: Boolean):Integer;
  begin
    if BCell
      then BinaryCells:=1
      else BinaryCells:=0;
  end;

Procedure LoadPreferences(GameID:Integer);
Var
  Size,N: Integer;
begin
  Size:=SizeOf(Cells);
  N:=PrefGetAppPreferences(CreatorID,GameID,@Cells,Size,True);
  if N<>noPreferenceFound then begin
    if GameID=0 then begin
      Speed:=BinaryCells(Cells[0,0].Previous)+2*BinaryCells(Cells[0,1].Previous);
      Filling:=BinaryCells(Cells[0,2].Previous)+2*BinaryCells(Cells[0,3].Previous);
      Editor:=Cells[0,4].Previous;
    end;
    CellSize:=3+BinaryCells(Cells[0,5].Previous)+2*BinaryCells(Cells[0,6].Previous);
    CalcCellSize;
    EraseDrawBoard;
  end
  else 
    case GameID of
      0: InitCells;
      1: N:=FrmAlert(NoLoad1);
      2: N:=FrmAlert(NoLoad2);
      3: N:=FrmAlert(NoLoad3);
    end;
end;

Function CalcDelay(NbSec:Integer):Boolean;
Var
  Delay: Integer;
begin
  CalcDelay:=False;
  Delay:=TimGetSeconds-DelaySeed;
  if NbSec<=Delay then begin
    DelaySeed:=TimGetSeconds;
    CalcDelay:=True;
  end;
end;

Procedure NextGeneration;
Var
  X,Y: Integer;
  N : Integer;
begin
  for X:=1 to CellXmax do
    for Y:=1 to CellYmax do 
      Cells[X,Y].Previous:=Cells[X,Y].Current;
  for X:=1 to CellXmax do
    for Y:=1 to CellYmax do begin
      N:=BinaryCells(Cells[X-1,Y-1].Previous)+BinaryCells(Cells[X,Y-1].Previous)+
         BinaryCells(Cells[X+1,Y-1].Previous)+BinaryCells(Cells[X-1,Y].Previous)+
         BinaryCells(Cells[X+1,Y].Previous)+BinaryCells(Cells[X-1,Y+1].Previous)+
         BinaryCells(Cells[X,Y+1].Previous)+BinaryCells(Cells[X+1,Y+1].Previous);
      Cells[X,Y].Current:=False;
      if Cells[X,Y].Previous then
        if ((N=2) or (N=3)) then 
          Cells[X,Y].Current:=True;
      if (not(Cells[X,Y].Previous) and (N=3)) then 
        Cells[X,Y].Current:=True;
    end;
  DrawGameBoard;  
end;

Function InsideGameBoard(var Event: EventType): Boolean;
begin
  with Event do
    InsideGameBoard:=RctPtInRectangle(ScreenX, ScreenY, WorkRect);
end;

Function HandleEvent(var Event: EventType): Boolean;
Var
  N: Integer;
  PForm: FormPtr;
begin
  HandleEvent:=True;
  with Event do 
  case eType of
  penDownEvent:
    begin
      if InsideGameBoard(Event) then 
        TickDown:=True
      else
        HandleEvent:=False;
    end;
  penUpEvent:
    begin
      if TickDown and InsideGameBoard(Event) then begin
        if Editor then 
          EditCell(ScreenX,ScreenY)
        else
          if Speed=3 then 
            NextGeneration;
        TickDown:=False;
      end
      else 
        HandleEvent:=False; 
    end;
  frmLoadEvent:
    begin
      PForm:=FrmInitForm(data.frmLoad.FormID);
      FrmSetActiveForm(PForm); 
      FrmSetEventHandlerNONE(PForm);  
      FormLoad:=True;
    end;
  frmOpenEvent: 
    begin
      FrmDrawForm(FrmGetActiveForm);
      FormOpen:=True;
    end;
  menuEvent:
    case Data.Menu.ItemID of
      MenuNewGame:     begin
                         N:=FrmAlert(StartNewGame1); 
                         if N=0 then InitCells;
                       end;
      MenuLoad1:       LoadPreferences(1);
      MenuLoad2:       LoadPreferences(2);
      MenuLoad3:       LoadPreferences(3);
      MenuSave1:       SavePreferences(1);
      MenuSave2:       SavePreferences(2);
      MenuSave3:       SavePreferences(3);
      MenuQuit:        DoStop:=True;
      MenuEditCurrent: Editor:=True;
      MenuEditNew:     begin
                         InitCurrentCells(0,0);
                         EraseDrawBoard;
                         Editor:=True;
                       end;
      MenuEndEdit:     Editor:=False;
      MenuSpeed:       case Speed of
                         0 : Speed:=FrmAlert(Speed1);
                         1 : Speed:=FrmAlert(Speed2);
                         2 : Speed:=FrmAlert(Speed3);
                         3 : Speed:=FrmAlert(Speed4);
                       end;
      MenuFilling:     case Filling of
                         0 : Filling:=FrmAlert(Filling1);
                         1 : Filling:=FrmAlert(Filling2);
                         2 : Filling:=FrmAlert(Filling3);
                         3 : Filling:=FrmAlert(Filling4);
                       end;
      MenuSize:        begin
                         case CellSize of 
                           3: CellSize:=FrmAlert(CellSize1)+3;
                           4: CellSize:=FrmAlert(CellSize2)+3;
                           5: CellSize:=FrmAlert(CellSize3)+3;
                         end;
                         CalcCellSize;
                         EraseDrawBoard;
                       end;
      MenuHelp:        N:=FrmAlert(Help1);
      MenuRules:       N:=FrmAlert(Rule1);
      MenuAbout:       N:=FrmAlert(About1);
    end;
  else
    HandleEvent:=False;
  end;
end;

Procedure Main;
Var
  Event: EventType;
  Error: UInt16;
  N: Integer;
  Freeze: Boolean;
begin
  Freeze:=False;
  RctSetRectangle(WorkRect, 0, 16, 160, 144);
  FrmGotoForm(MainForm);
  Repeat
    EvtGetEvent(Event, 5);
    if not SysHandleEvent(Event) then
      if MenuHandleEvent(MyMenu,Event,Error) then
        Freeze:=True
      else 
        if not FrmDispatchEvent(Event) then
          if HandleEvent(Event) then
            Freeze:=False
          else
            if (FormLoad and FormOpen) then 
              if (Speed<3) and CalcDelay(Speed) and not(Freeze) and not(Editor) then begin
                NextGeneration;
                if (BinaryCells(Cells[1,33].Current)+
                    BinaryCells(Cells[1,34].Current)+ 
                    BinaryCells(Cells[2,33].Current)+
                    BinaryCells(Cells[2,34].Current)=4) then
                  DoStop:=True;
              end; 
  Until DoStop; //or (Event.eType=appStopEvent);
//  SavePreferences(0); 
  if FrmGetActiveForm<>NIL then begin
    FrmEraseForm(FrmGetActiveForm);
    FrmDeleteForm(FrmGetActiveForm);
  end;
end;

Procedure SpeedBeg;
begin
  InitCurrentCells(0,0);
  Cells[37,40].Current:=True;
  Cells[36,40].Current:=True;
  Cells[34,40].Current:=True;
  Cells[36,39].Current:=True;
  Cells[35,39].Current:=True;
  Cells[34,39].Current:=True;
  Cells[35,38].Current:=True;
  EraseDrawBoard;
end;

Procedure SpeedEnd;
Var
  N: Integer;
begin
  N:=StopTimer;
  N:=frmCustomAlert(ResultWindow,'SCells test lasted ',i2s(N),' seconds.');
end;

begin
  StartTimer;
  Randomize;
  InitVar;
//  LoadPreferences(0);
  SpeedBeg;
  Main;
  SpeedEnd;
end.
